--- dmd-0.177/src/phobos/std/loader.d	Sat Dec  9 01:17:14 2006
+++ gdc-0.20-dev/d/phobos/std/loader.d	Sun Dec 10 10:47:10 2006
@@ -8,7 +8,7 @@
  *
  * Author:      Matthew Wilson
  *
- * License:     (Licensed under the Synesis Software Standard Source License)
+ * License:
  *
  *              Copyright (C) 2002-2004, Synesis Software Pty Ltd.
  *
@@ -20,25 +20,19 @@
  *              email:      submissions@synsoft.org  for submissions
  *                          admin@synsoft.org        for other enquiries
  *
- *              Redistribution and use in source and binary forms, with or
- *              without modification, are permitted provided that the following
- *              conditions are met:
- *
- *              (i) Redistributions of source code must retain the above
- *              copyright notice and contact information, this list of
- *              conditions and the following disclaimer.
- *
- *              (ii) Any derived versions of this software (howsoever modified)
- *              remain the sole property of Synesis Software.
- *
- *              (iii) Any derived versions of this software (howsoever modified)
- *              remain subject to all these conditions.
- *
- *              (iv) Neither the name of Synesis Software nor the names of any
- *              subdivisions, employees or agents of Synesis Software, nor the
- *              names of any other contributors to this software may be used to
- *              endorse or promote products derived from this software without
- *              specific prior written permission.
+ *      	Permission is granted to anyone to use this software for any purpose,
+ *      	including commercial applications, and to alter it and redistribute it
+ *      	freely, in both source and binary form, subject to the following
+ *      	restrictions:
+ *      	
+ *      	-  The origin of this software must not be misrepresented; you must not
+ *      	   claim that you wrote the original software. If you use this software
+ *      	   in a product, an acknowledgment in the product documentation would be
+ *      	   appreciated but is not required.
+ *      	-  Altered source versions must be plainly marked as such, and must not
+ *      	   be misrepresented as being the original software.
+ *      	-  This notice may not be removed or altered from any source
+ *      	   distribution.
  *
  *              This source code is provided by Synesis Software "as is" and any
  *              warranties, whether expressed or implied, including, but not
--- dmd-0.177/src/phobos/std/windows/registry.d	Sat Dec  9 01:17:16 2006
+++ gdc-0.20-dev/d/phobos/std/windows/registry.d	Sun Dec 10 10:47:07 2006
@@ -8,7 +8,7 @@
  *
  * Author:      Matthew Wilson
  *
- * License:     (Licensed under the Synesis Software Standard Source License)
+ * License:
  *
  *              Copyright (C) 2002-2004, Synesis Software Pty Ltd.
  *
@@ -20,25 +20,19 @@
  *              email:      submissions@synsoft.org  for submissions
  *                          admin@synsoft.org        for other enquiries
  *
- *              Redistribution and use in source and binary forms, with or
- *              without modification, are permitted provided that the following
- *              conditions are met:
- *
- *              (i) Redistributions of source code must retain the above
- *              copyright notice and contact information, this list of
- *              conditions and the following disclaimer.
- *
- *              (ii) Any derived versions of this software (howsoever modified)
- *              remain the sole property of Synesis Software.
- *
- *              (iii) Any derived versions of this software (howsoever modified)
- *              remain subject to all these conditions.
- *
- *              (iv) Neither the name of Synesis Software nor the names of any
- *              subdivisions, employees or agents of Synesis Software, nor the
- *              names of any other contributors to this software may be used to
- *              endorse or promote products derived from this software without
- *              specific prior written permission.
+ *      	Permission is granted to anyone to use this software for any purpose,
+ *      	including commercial applications, and to alter it and redistribute it
+ *      	freely, in both source and binary form, subject to the following
+ *      	restrictions:
+ *      	
+ *      	-  The origin of this software must not be misrepresented; you must not
+ *      	   claim that you wrote the original software. If you use this software
+ *      	   in a product, an acknowledgment in the product documentation would be
+ *      	   appreciated but is not required.
+ *      	-  Altered source versions must be plainly marked as such, and must not
+ *      	   be misrepresented as being the original software.
+ *      	-  This notice may not be removed or altered from any source
+ *      	   distribution.
  *
  *              This source code is provided by Synesis Software "as is" and any
  *              warranties, whether expressed or implied, including, but not